package org.example.mybatisplus.Controller;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONArray;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;

import org.example.mybatisplus.model.auto.CmsEnterpriseRiskInfoCheckBO;
import org.example.mybatisplus.model.auto.CmsEnterpriseRiskInfoDeclaration;
import org.example.mybatisplus.model.auto.CmsEnterpriseRiskQxbInfoBO;
import org.example.mybatisplus.module.*;
import org.example.mybatisplus.module.vo.*;
import org.example.mybatisplus.tools.DocxGenerator;
import org.example.mybatisplus.tools.WordToPdfUtil;
import org.springframework.core.io.FileSystemResource;
import org.springframework.core.io.Resource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.*;
import java.util.*;

@ApiOperation("控制类")
@RestController
public class IndexController {
    public static void main(String[] args) throws IOException {

        String wordExportpath = System.getProperty("user.dir")+File.separator+ "jijinhui1.docx";
        String pdfFilePath =System.getProperty("user.dir")+File.separator+  "download.pdf";

        ServiceProviderInfo serviceProviderInfo=new ServiceProviderInfo();
        serviceProviderInfo.setName("海潮基金会");
        serviceProviderInfo.setType("基金会");
        serviceProviderInfo.setReportDate("2025-03-11");
        AuditResult auditResult=new AuditResult();
        auditResult.setAuditDate("2025-03-11");
        auditResult.setScore("222");
        auditResult.setOpinion("test");
        auditResult.setServiceProviderName("服务商2");
        String str=" [\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"净资产评级\",\n" +
                "        \"category\": \"基础信息\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"发展能力-总收入增长率\",\n" +
                "        \"category\": \"财务信息\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"项目信息\",\n" +
                "        \"category\": \"项目信息\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"运营年限\",\n" +
                "        \"category\": \"基础信息\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"失信被执行人\",\n" +
                "        \"category\": \"公共记录\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"基金会捐赠收入规模\",\n" +
                "        \"category\": \"基础信息\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"发展能力-公益支出增长率\",\n" +
                "        \"category\": \"财务信息\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"严重违法\",\n" +
                "        \"category\": \"公共记录\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"运营能力-私募基金-公益支出\",\n" +
                "        \"category\": \"财务信息\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"运营能力-私募基金-管理费用\",\n" +
                "        \"category\": \"财务信息\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"税务处罚\",\n" +
                "        \"category\": \"公共记录\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"MOCA评级\",\n" +
                "        \"category\": \"基础信息\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"经营异常\",\n" +
                "        \"category\": \"公共记录\"\n" +
                "      },\n" +
                "      {\n" +
                "        \"score\": 1,\n" +
                "        \"itemName\": \"行政处罚\",\n" +
                "        \"category\": \"公共记录\"\n" +
                "      }\n" +
                "    ]";
        List<CheckItemScore> slist=JSONArray.parseArray(str,CheckItemScore.class);

        // 定义固定的排序顺序
        List<String> fixedOrder = List.of("基础信息", "公共记录", "财务信息","项目情况");
        Map<String, Integer> orderMap = new HashMap<>();
        for (int i = 0; i < fixedOrder.size(); i++) {
            orderMap.put(fixedOrder.get(i), i);
        }

        // 使用 Comparator 对列表进行排序
        Collections.sort(slist, Comparator.comparingInt(person -> orderMap.getOrDefault(person.getCategory(), Integer.MAX_VALUE)));

        System.out.println(JSON.toJSONString(slist));
        auditResult.setCheckItemScores(slist);

        BasicInfo basicInfo = new BasicInfo();
        basicInfo.setBasicInfoScore(new BasicInfoScore(
                66l,
                "哈哈哈",
                "测试"
        ));
        // 将图片转换为 Base64 编码
//        String imageBase64 = DocxGenerator.convertImageToBase64("G:\\Code\\new\\fxy-tool\\src\\main\\resources\\pic1.png");
        Attachment attach = new Attachment();
        attach.setFilePath("https://manage.xiuqiuengineering.com/api//profile/upload/2024/04/24/2024/04/26/banner.jpg");
        List<Attachment> attachments= Arrays.asList(attach);
        basicInfo.setRelatedEntitiesImage(attachments);

        PublicRecord publicRecord=new PublicRecord();
        DishonestPersonsInfoVO person=new DishonestPersonsInfoVO();
        person.setInDate("2025-03-08");
        person.setCaseNumber("1111");
        person.setAmount("Behavior多个");
        person.setExecutionDesc("gCourt");
        person.setCourt("nsubiec有");
        person.setDisabled("是");
        List<DishonestPersonsInfoVO> persons=new ArrayList<>();
        persons.add(person);
        publicRecord.setDishonestPersons(persons);

        publicRecord.setPublicRecordScore(new PublicRecordScore());
        FinancialInfo financialInfo=new FinancialInfo();
        financialInfo.setFinancialData1(new FinancialData());//new 空对象防止模板空指针
        financialInfo.setFinancialData2(new FinancialData());
        financialInfo.setFinancialData3(new FinancialData());
        financialInfo.setFinancialData4(new FinancialData());
        financialInfo.setFinancialScore(new FinancialScore());
        ProjectInfo projectInfo=new ProjectInfo();
        projectInfo.setFiles(attachments);
        DocumentVo documentVo=new DocumentVo();

        ServiceProviderAuditReport report=new ServiceProviderAuditReport();//基金会数据
        report.setServiceProviderInfo(serviceProviderInfo);
        report.setAuditResult(auditResult);
        report.setBasicInfo(basicInfo);
        report.setPublicRecord(publicRecord);
        report.setFinancialInfo(financialInfo);
        report.setProjectInfo(projectInfo);
        report.setDocumentVo(documentVo);
        report.setInterestConflict(attachments);

        PlatformReport platformReport=new PlatformReport();//平台报告数据
        platformReport.setServiceProviderInfo(serviceProviderInfo);
        platformReport.setAuditResult(auditResult);
        RegistrationInfo registrationInfo=new RegistrationInfo();
        registrationInfo.setBasicInfoScore(new BasicInfoScore(
                66l,
                "哈哈哈",
                "测试"
        ));
        platformReport.setRegistrationInfo(registrationInfo);
        platformReport.setPublicRecord(publicRecord);
        financialInfo.setAntiBribery(new PublicRecordScore());
        platformReport.setFinancialInfo(financialInfo);
        platformReport.setDocumentVo(new PlateDocumentVo());


        AssociationReport associationReport=new AssociationReport();//学协会报告数据
        associationReport.setServiceProviderInfo(serviceProviderInfo);
        associationReport.setAuditResult(auditResult);
        AssociationInfo associationInfo=new AssociationInfo();
        associationInfo.setBasicInfoScore(new BasicInfoScore(
                66l,
                "哈哈哈",
                "测试"
        ));
        associationReport.setRegistrationInfo(associationInfo);
        associationReport.setPublicRecord(publicRecord);
        associationReport.setProjectInfo(projectInfo);
        financialInfo.setAntiBribery(new PublicRecordScore());
        associationReport.setFinancialInfo(financialInfo);
        associationReport.setDocumentVo(new AssocDocumentVo());
        try {
            //基金会模板foundation_template.xml
            //平台模板platform_template.xml
            //学协会模板association_template.xml
            // 生成Word文档
            DocxGenerator.init(report,"foundation_template.xml",wordExportpath);
            // 将Word文档转换为PDF
            WordToPdfUtil.wordToPdf(wordExportpath,pdfFilePath);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //只要接口中，返回值存在实体类,就会被扫描到swagger中
    @GetMapping("/export")
    public ResponseEntity<Resource> export(@ApiParam("param")String param /* todo: 参数：服务商ID，校验ID，报告类型*/){

        String wordFilePath = System.getProperty("user.dir")+File.separator+ "jijinhui.docx";
        String wordExportpath = System.getProperty("user.dir")+File.separator+ "jijinhui1.docx";
        String pdfFilePath =System.getProperty("user.dir")+File.separator+  "download.pdf";

        // todo:
        ServiceProviderInfo serviceProviderInfo=new ServiceProviderInfo();
        serviceProviderInfo.setName("海潮基金会");
        serviceProviderInfo.setReportDate("2025-03-24");
        // 1. getWordTemplate for BasicInfo
        // 2. retrieve data
        //    2.1 get CmsEnterpriseRiskQxbInfoBO
        CmsEnterpriseRiskQxbInfoBO cmsEnterpriseRiskQxbInfoBO = org.example.mybatisplus.model.auto.CmsEnterpriseRiskQxbInfoBO.builder().build(); // mock
        CmsEnterpriseRiskInfoDeclaration cmsEnterpriseRiskInfoDeclaration = new CmsEnterpriseRiskInfoDeclaration(); // mock
        CmsEnterpriseRiskInfoCheckBO cmsEnterpriseRiskInfoCheckBO = new CmsEnterpriseRiskInfoCheckBO();

        // 3. fill 
        AuditResult auditResult=new AuditResult();
        auditResult.setReportVersion("PLUS版");
        auditResult.setServiceProviderName("上海医药行业协会");
        cmsEnterpriseRiskQxbInfoBO.fillAuditResultVO(auditResult);
        cmsEnterpriseRiskInfoDeclaration.fillAuditResultVO(auditResult);
        cmsEnterpriseRiskInfoCheckBO.fillAuditResultVO(auditResult);


        BasicInfo basicInfo = new BasicInfo();
        cmsEnterpriseRiskQxbInfoBO.fillBasicInfoVO(basicInfo);
        cmsEnterpriseRiskInfoDeclaration.fillBasicInfoVO(basicInfo);
        cmsEnterpriseRiskInfoCheckBO.fillBasicInfoVO(basicInfo);

        // 4. render WordTemplate with BasicInfo

        // ...

        // 最后把所有片段合成一个完整报告

        ServiceProviderAuditReport report=new ServiceProviderAuditReport();
        report.setServiceProviderInfo(serviceProviderInfo);
        report.setBasicInfo(basicInfo);
        report.setAuditResult(auditResult);
        try {
            //JSONObject jsonObject = JSONObject.parseObject(JSONObject.toJSONString(report));
            // 生成Word文档
            //WordPoiExporter.init(wordFilePath,wordExportpath,jsonObject);
            // 生成Word文档
            DocxGenerator.init(report,"foundation_template.xml",wordExportpath);
            // 将Word文档转换为PDF
            WordToPdfUtil.wordToPdf(wordExportpath,pdfFilePath);
        } catch (Exception e) {
            e.printStackTrace();
        }

        File file = new File(pdfFilePath);
        Resource resource = new FileSystemResource(file);

        HttpHeaders headers = new HttpHeaders();
        headers.add(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=" + file.getName());

        return ResponseEntity.ok()
                .headers(headers)
                .contentLength(file.length())
                .contentType(MediaType.APPLICATION_PDF)
                .body(resource);
    }


}
