package org.example.mybatisplus.module;

import lombok.Data;
import org.example.mybatisplus.module.vo.Attachment;
import org.example.mybatisplus.module.vo.BasicInfoCheck;
import org.example.mybatisplus.module.vo.BasicInfoScore;
import org.example.mybatisplus.module.vo.SuperiorAuthority;

import java.util.List;

/**
 * 协会基础信息
 */
@Data
public class AssociationInfo {
    /**
     * 协会全称
     */
    private String associationName;
    /**
     * 业务主管单位名称
     */
    private String supervisoryUnitName;
    /**
     * 成立登记日期（格式：yyyy-MM-dd）
     */
    private String establishmentDate;
    /**
     * 登记有效期（格式：yyyy-MM-dd）
     */
    private String registrationValidity;
    /**
     * 官方网站链接
     */
    private String officialWebsite;
    /**
     * 注册资金（单位：万元）
     */
    private String registeredCapital;
    /**
     * 机构宗旨
     */
    private String missionStatement;
    /**
     * 业务范围描述
     */
    private String businessScope;

    /**
     * 法定代表人
     */
    private String legalRepresentative;
    /**
     * 协会评估等级（如：3A）
     */
    private String associationRating;
    /**
     * 实际办公地址
     */
    private String officeAddress;
    /**
     * 联系电话
     */
    private String contactNumber;
    /**
     * 单位会员数量（如：超x家）
     */
    private String corporateMembers;
    /**
     * 个人会员数量
     */
    private Integer individualMembers;
    /**
     * 会费收取标准（多行文本）
     */
    private String membershipFeeStandard;

    /**
     * 主要活动覆盖地域（示例：长三角地区）
     */
    private String mainActivityRegion;
    /**
     * 上一年度xxx公司赞助和捐赠额占总社会赞助和捐赠比例（单位：%，示例：1%）
     */
    private String sponsorshipRatio;
    /**
     * 是否通常需要外包合作项目（true/false）
     */
    private String useExternalService;
    /**
     * 项目服务执行方名单（如：无/合作方名称列表）
     */
    private String projectServiceVendors;

    // 审查内容
    private List<BasicInfoCheck> basicInfoChecks;
    private List<SuperiorAuthority> superiorAuthority; // 业务主管单位情
    private List<Attachment> relatedEntitiesImage;            // 支机构或专业委员会情况


    private String foundationCertReceived;    // ${经营情况:《社会团体法人登记证书》:相关资料是否收到}
    private String renzcode;               // ${认证代码}
    private String validate;               // ${有效期}
    // ${统一社会信用代码}
    private String companyCode;
    private String companyRenzcode;               // ${认证代码}
    private String companyValidate;               // ${有效期}
    private String bankLicense;             //银行开户许可证
    private String annualInspectionResult;    // ${经营情况:年检结果}
    private BasicInfoScore basicInfoScore;          // 基本信息评分及建议（2.5）
}
