package org.example.mybatisplus.module;

import lombok.Data;
import org.example.mybatisplus.module.vo.Attachment;
import org.example.mybatisplus.module.vo.BasicInfoCheck;
import org.example.mybatisplus.module.vo.BasicInfoScore;

import java.util.List;

//平台公司注册信息
@Data
public class RegistrationInfo {
    /**
     * 公司全称
     */
    private String companyName;
    /**
     * 所属行业
     */
    private String industry;
    /**
     * 法定代表人
     */
    private String legalRepresentative;
    /**
     * 注册资本（单位：人民币万元）
     */
    private String registeredCapital;
    /**
     * 实缴资本（单位：人民币万元）
     */
    private String paidInCapital;
    /**
     * 企业规模（如：小型）
     */
    private String enterpriseScale;
    /**
     * 参保人数
     */
    private Integer insuredEmployees;
    /**
     * 经营状态（如：存续）
     */
    private String businessStatus;
    /**
     * 登记机关
     */
    private String registrationAuthority;
    /**
     * 成立日期（格式：yyyy-MM-dd）
     */
    private String establishmentDate;
    /**
     * 注册地址
     */
    private String registeredAddress;
    /**
     * 纳税人资质（如：增值税一般纳税人）
     */
    private String taxpayerQualification;
    /**
     * 企业类型（如：有限责任公司）
     */
    private String enterpriseType;
    /**
     * 经营范围
     */
    private String businessScope;

    // 审查内容
    private List<BasicInfoCheck> basicInfoChecks;
    private List<Attachment> relatedEntitiesImage;            // ${image:实体关联情况}（2.3）
    private String foundationCertReceived;    // ${经营情况:《基金会法人登记证书》:相关资料是否收到}
    private String renzcode;               // ${认证代码}
    private String validate;               // ${有效期}
    private String bankLicense;               // ${经营情况:银行开户许可证}
    private String bankRenzcode;               // ${认证代码}
    private String bankValidate;               // ${有效期}
    private String annualInspectionResult;    // ${经营情况:年检结果}
    private BasicInfoScore basicInfoScore;          // 基本信息评分及建议（2.5）
}
